﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SceneManager : UnitySingleton<SceneManager>
{

    public bool IsDraging { set; get; }

    public int sceneid = 0;

    public bool IsLogo = true;

    public List<string> fileName;

    public bool checkWining { set; get; }
   

    public void OpenScene(int sceneID)
    {
        Application.LoadLevel(sceneID);
    }

    public void Reset()
    {
        IsDraging = false;
        if (!IsLogo)
        {
            if(GameObject.Find("LOGO")!=null)
                GameObject.Find("LOGO").SetActive(false);
        }

        GameObject.Find("left").GetComponent<BoxCollider2D>().enabled = true;
        GameObject.Find("right").GetComponent<BoxCollider2D>().enabled = true;
        GameObject.Find("reset").GetComponent<BoxCollider2D>().enabled = true;
        GameObject.Find("left").GetComponent<SpriteRenderer>().enabled = true;
        GameObject.Find("left").GetComponent<SpriteRenderer>().enabled = true;
        if (sceneid == 0)
            GameObject.Find("left").GetComponent<SpriteRenderer>().enabled = false;
        if(sceneid == 5)
            GameObject.Find("right").GetComponent<SpriteRenderer>().enabled = false;
        // AudioManager.Instance.PlayBackage();
        checkWining = false;
    }
    void Start()
    {
        
        IsLogo = true;
        
        StartCoroutine(FinshLogo());

    }
    /*void OnGUI()
    {
        if (GUILayout.Button("下一关"))
        {
            IsDraging = false;
            StoneManager.Instance.isWin = true;
            ReloadNextScene();
            //StoneManager.Instance.PlayFuwen();
        }
    }*/

    public IEnumerator FinshLogo()
    {
        yield return new WaitForSeconds(5);
        IsLogo = false;
    }

    public IEnumerator FinshBuild()
    {
        StoneManager.Instance.PlayFuwen();
        yield return new WaitForSeconds(3);
        
        if (StoneManager.Instance.isWin)
        {
            StoneManager.Instance.PlayWin();
            yield return new WaitForSeconds(5);
            checkWining = false;
            if (sceneid > 5)
                sceneid = 0;
            
            SceneManager.Instance.OpenScene(++sceneid);
        }
        else
        {
            checkWining = false;
        }
       
    }

    public void ReloadScene()
    {
        OpenScene(sceneid);
    }

    public void ReloadPreScene()
    {
        sceneid--;
        if (sceneid > 5) sceneid = 0;
        OpenScene(sceneid);
    }

    public void ReloadNextScene1()
    {
        sceneid++;
        OpenScene(sceneid);
    }

    public void ReloadNextScene()
    {
        if (!IsDraging)
        {
            checkWining = true;
            StartCoroutine(FinshBuild());
        }
    }


    

}
