﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Reflection.Emit;

public class StoneManager : UnitySingleton<StoneManager>
{
    // Use this for initialization
    private GameObject[] stroneGameobj;
    private GameObject[] targetColider;

    private GameObject btnFuwen;
    private SpriteRenderer sr;
    private GameObject end;
    private int count;
    public bool isWin { get; set; }
    private void Start()
    {
        count = 0;
        ResetStrone();
        
    }


    public void ResetStrone()
    {
        stroneGameobj = GameObject.FindGameObjectsWithTag(Constant.StoneTag);
        targetColider = GameObject.FindGameObjectsWithTag(Constant.TargetTag);
       
        count = 0;
        if (targetColider.Length > 0)
        {
            for (int i = 0; i < targetColider.Length; i++)
            {
                OpenEffect1(targetColider[i]);
            }
        }

        btnFuwen = GameObject.Find("fuwen3");
        //end = GameObject.Find("end");
        //end.SetActive(false);
        //end.SetActive(false);
        //end.GetComponent<Animator>().Stop();
       // end.transform.Find("light").GetComponent<ParticleSystem>().Stop();
        //end.GetComponent<SpriteRenderer>().enabled = false;
        sr = btnFuwen.GetComponent<SpriteRenderer>();
        StopFuwen();
        btnFuwen.GetComponent<BoxCollider2D>().enabled = false;
    }

    // Update is called once per frame
    private void Update()
    {
        count = 0;
        
        if (targetColider.Length > 0)
        {
            for (int i = 0; i < targetColider.Length; i++)
            {
                RaycastHit2D hit;
                Vector3 pos = targetColider[i].transform.position;
                hit = Physics2D.Raycast(pos, Vector2.zero, -Mathf.Infinity, LayerMask.GetMask(Constant.StoneTag));
                if (hit.transform != null/* && hit.transform.gameObject.name == targetColider[i].name*/)
                {
                        //sr.color = Color.green;
                        OpenEffect2(targetColider[i]);
                        count++;
                }
                else
                {
                    OpenEffect1(targetColider[i]);
                }

                //PolygonCollider2DEx.add
                //Click.setPress(stroneGameobj[i], PressStone);
            }
        }

        if (count == targetColider.Length)
        {
            //SceneManager.Instance.ReloadNextScene();
            btnFuwen.GetComponent<BoxCollider2D>().enabled = true;
            sr.color = Color.white;
            isWin = true;
            //SceneManager.Instance.OpenScene(1);
        }
        else
        {
            isWin = false;
            sr.color = new Color(0 * 20, 0 * 20, 0 * 20, 255);
        }

    }

    public void PlayWin()
    {
        GameObject temp = (GameObject)Resources.Load("Prefabs/end_"+SceneManager.Instance.sceneid);
        
        GameObject obj = GameObject.Instantiate(temp);
        obj.name = "win";
        AudioManager.Instance.PlayWin();
        /*end.GetComponent<SpriteRenderer>().enabled = true;
        end.transform.Find("light").GetComponent<ParticleSystem>().Play();
        end.transform.GetComponent<Animator>().Play("end",-1,0);
        end.transform.GetComponent<Animator>().Update(0);*/

        //AudioManager.Instance.PlayWin();
        //GameObject.Find("end").SetActive(true);
    }

    public void PlayFuwen()
    {
         GameObject temp = (GameObject)Resources.Load("Prefabs/check");
         GameObject obj = GameObject.Instantiate(temp);
        obj.name = "check";
        /*GameObject.Find("fuwen1").GetComponent<SpriteRenderer>().enabled = true;// SetActive(true);
        GameObject.Find("fuwen2").GetComponent<SpriteRenderer>().enabled = true;
        GameObject.Find("fire_01").GetComponent<ParticleSystem>().Clear();
        GameObject.Find("fire_01").GetComponent<ParticleSystem>().Play();
        GameObject.Find("fire_02").GetComponent<ParticleSystem>().Play();
        
        GameObject.Find("check").GetComponent<Animator>().Play("check", -1, 0);
        GameObject.Find("check").GetComponent<Animator>().Update(0);*/
    }

    public void StopFuwen()
    {
        if (GameObject.Find("check"))
        {
            Destroy(GameObject.Find("check"));
        }
        /*GameObject.Find("fuwen1").GetComponent<SpriteRenderer>().enabled = false;
        GameObject.Find("fuwen2").GetComponent<SpriteRenderer>().enabled = false;

        GameObject.Find("fire_01").GetComponent<ParticleSystem>().Stop();
        GameObject.Find("fire_02").GetComponent<ParticleSystem>().Stop();*/

        //GameObject.Find("check").GetComponent<Animator>().Stop();
    }

    private void OpenEffect1(GameObject obj)
    {
        //GameObject game = obj..Find("");
        if (obj.transform.Find("point")!=null)
            obj.transform.Find("point").gameObject.SetActive(true);
        if(obj.transform.Find("point_active")!=null)
            obj.transform.Find("point_active").gameObject.SetActive(false);
    }

    private void OpenEffect2(GameObject obj)
    {
        obj.transform.Find("point").gameObject.SetActive(false);
        obj.transform.Find("point_active").gameObject.SetActive(true);
    }
    

    void OnLevelWasLoaded()
    {
        ResetStrone();
    }

    public  void CloseKinematic()
    {
        if (stroneGameobj.Length > 0)
        {
            for (int i=0;i< stroneGameobj.Length;i++)
            {
                stroneGameobj[i].GetComponent<Rigidbody2D>().isKinematic = false;

            }
        }
    }

}

    
