using UnityEngine;
public class UnityAllSceneSingleton<T> : MonoBehaviour 
where T:Component {
private static T _instance;
public static T Instance        {
	get{
		if(_instance == null){
			_instance = FindObjectOfType(typeof(T)) as T;
			if(_instance == null){
				GameObject obj = new GameObject ();
				//obj.hideFlags = HideFlags.DontSave;
				obj.hideFlags = HideFlags.HideAndDontSave;
				_instance =(T) obj.AddComponent(typeof(T));
			}
		}
		return _instance;
	}
}
public virtual void Awake()
{
	DontDestroyOnLoad(this.gameObject);
	if(_instance == null){
		_instance = this as T;
	}
	else{
		Destroy(gameObject);
	}
}
}